//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UMain.h"
#include "UAdaptCase.h"
#include "UFilter.h"
#include "USniffThrd.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFMain *FMain;

TSniffThrd *Thrd;


u_long LocalAddrs[10];
u_long LocalMasks[10];
__int64 LocalMACs[10];

HINSTANCE iphlpapi_dll;
DWORD (__stdcall * GetAdaptersInfo)(PIP_ADAPTER_INFO pAdapterInfo, PULONG pOutBufLen);






//---------------------------------------------------------------------------
__fastcall TFMain::TFMain(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TFMain::FormCreate(TObject *Sender)
{
        SGStat->RowCount = 2;
        SGStat->RowHeights[0] = 20;
        SGStat->RowHeights[1] = 20;

        SGStat->Cells[0][0] = "";
        SGStat->Cells[1][0] = "";
        SGStat->Cells[2][0] = "";
        SGStat->Cells[3][0] = "-";
        SGStat->Cells[4][0] = "-";
        SGStat->Cells[5][0] = " IP-";

        SGStat->ColWidths[0] = (SGStat->Width -10)/6;
        SGStat->ColWidths[1] = (SGStat->Width -10)/6;
        SGStat->ColWidths[2] = (SGStat->Width -10)/6;
        SGStat->ColWidths[3] = (SGStat->Width -10)/6;
        SGStat->ColWidths[4] = (SGStat->Width -10)/6;
        SGStat->ColWidths[5] = (SGStat->Width -10)/6;


        WORD vers;
        WSADATA WSAData;
        if ( WSAStartup (MAKEWORD (2,2),&WSAData))
                if ( WSAStartup (MAKEWORD (2,0),&WSAData))
                        if ( WSAStartup (MAKEWORD (1,1),&WSAData))
                        {
                         ShowMessage("    Winsock DLL");
                         return;
                        }

}
//---------------------------------------------------------------------------

void __fastcall TFMain::FormResize(TObject *Sender)
{
        SGStat->ColWidths[0] = (SGStat->Width -10)/6;
        SGStat->ColWidths[1] = (SGStat->Width -10)/6;
        SGStat->ColWidths[2] = (SGStat->Width -10)/6;
        SGStat->ColWidths[3] = (SGStat->Width -10)/6;
        SGStat->ColWidths[4] = (SGStat->Width -10)/6;
        SGStat->ColWidths[5] = (SGStat->Width -10)/6;
}
//---------------------------------------------------------------------------
void __fastcall TFMain::FormShow(TObject *Sender)
{
        iphlpapi_dll = LoadLibrary ("iphlpapi.dll");
        GetAdaptersInfo =  (DWORD  (__stdcall *) (PIP_ADAPTER_INFO pAdapterInfo, PULONG pOutBufLen)) GetProcAddress (iphlpapi_dll,"GetAdaptersInfo");

        PIP_ADAPTER_INFO pAdapterInfo, pAdapt;
        DWORD AdapterInfoSize;
        DWORD Err;
        int cnt;
        sockaddr_in saddr;


        AdapterInfoSize = 0;
        GetAdaptersInfo(NULL, &AdapterInfoSize);

        pAdapterInfo = (PIP_ADAPTER_INFO) GlobalAlloc(GPTR, AdapterInfoSize);
        if (pAdapterInfo == NULL)
        {
                return ;
        }

        if ((GetAdaptersInfo(pAdapterInfo, &AdapterInfoSize))!=0)
        {
                return ;
        }

        cnt = 0;
        pAdapt = pAdapterInfo;
        while (pAdapt)
        {
                FAdaptCase->ListBox1->Items->Add(pAdapt->Description);
                cnt++;
                LocalAddrs[cnt-1]= inet_addr(pAdapt->IpAddressList.IpAddress.String);
                LocalMasks[cnt-1]= inet_addr(pAdapt->IpAddressList.IpMask.String);

                pAdapt = pAdapt->Next;

        }
        saddr.sin_addr.S_un.S_addr = LocalAddrs[0];
        FAdaptCase->Label3->Caption = inet_ntoa(saddr.sin_addr);
        saddr.sin_addr.S_un.S_addr = LocalMasks[0];
        FAdaptCase->Label4->Caption = inet_ntoa(saddr.sin_addr);
        FAdaptCase->ListBox1->Items->Add(" ");

}
//---------------------------------------------------------------------------
void __fastcall TFMain::TBAdaptCaseClick(TObject *Sender)
{
        FAdaptCase->ShowModal();        
}
//---------------------------------------------------------------------------
void __fastcall TFMain::TBFilterClick(TObject *Sender)
{
        FFilter->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TFMain::TBStartClick(TObject *Sender)
{
        ULONG sAddr,dAddr;
        int proto,sPort,dPort;
        protoent *pe;
        pe = new protoent;


        if (FFilter->CBSrcIP->Checked) sAddr = inet_addr(FFilter->ESrcIP->Text.c_str());else sAddr = 0;
        if (FFilter->CBDstIP->Checked) dAddr = inet_addr(FFilter->EDstIP->Text.c_str());else dAddr = 0;
        if (FFilter->CBProto->Checked)
        {
                pe = getprotobyname(FFilter->CBoxProto->Text.c_str());
                proto = pe->p_proto;
        }
        else proto = 0;
        if (FFilter->CBSrcPort->Checked) sPort = FFilter->ESrcPort->Text.ToInt(); else sPort = 0;
        if (FFilter->CBDstPort->Checked) dPort = FFilter->EDstPort->Text.ToInt(); else dPort = 0;

        TBStart->Enabled = false;
        TBStop->Enabled = true;

        Thrd = new TSniffThrd(true);
        Thrd->SetFilter(sAddr,dAddr,proto,sPort,dPort);
        Thrd->Resume();
}
//---------------------------------------------------------------------------
void __fastcall TFMain::TBStopClick(TObject *Sender)
{
        TBStart->Enabled = true;
        TBStop->Enabled = false;
        Thrd->Terminate();
}
//---------------------------------------------------------------------------

void __fastcall TFMain::TBClearClick(TObject *Sender)
{
        SGStat->RowCount = 3;

        for (int i = 0;i<=5;i++)
        {
                SGStat->Cells[i][1] = "";
                SGStat->Cells[i][2] = "";
        }
        SGStat->RowCount = 2;


}
//---------------------------------------------------------------------------

void __fastcall TFMain::TBExitClick(TObject *Sender)
{
        Application->Terminate();        
}
//---------------------------------------------------------------------------

